diff --git a/arch/arm/dts/Makefile b/arch/arm/dts/Makefile
index 66ea0b3..b117b51 100644
--- a/arch/arm/dts/Makefile
+++ b/arch/arm/dts/Makefile
@@ -36,7 +36,7 @@ dtb-$(CONFIG_ARCH_ROCKCHIP) += \
 	rk3288-rock2-square.dtb \
 	rk3288-evb.dtb \
 	rk3288-fennec.dtb \
-	rk3288-miniarm.dtb \
+	rk3288-tinker.dtb \
 	rk3288-popmetal.dtb \
 	rk3399-evb.dtb
 dtb-$(CONFIG_ARCH_MESON) += \
diff --git a/arch/arm/dts/rk3288-miniarm.dts b/arch/arm/dts/rk3288-tinker.dts
similarity index 86%
rename from arch/arm/dts/rk3288-miniarm.dts
rename to arch/arm/dts/rk3288-tinker.dts
index 9083028..4dacc76 100644
--- a/arch/arm/dts/rk3288-miniarm.dts
+++ b/arch/arm/dts/rk3288-tinker.dts
@@ -5,11 +5,11 @@
  */
 
 /dts-v1/;
-#include "rk3288-miniarm.dtsi"
+#include "rk3288-tinker.dtsi"
 
 / {
-	model = "Miniarm-RK3288";
-	compatible = "rockchip,rk3288-miniarm", "rockchip,rk3288";
+	model = "Tinker-RK3288";
+	compatible = "rockchip,rk3288-tinker", "rockchip,rk3288";
 
 	chosen {
 		stdout-path = &uart2;
diff --git a/arch/arm/dts/rk3288-miniarm.dtsi b/arch/arm/dts/rk3288-tinker.dtsi
similarity index 100%
rename from arch/arm/dts/rk3288-miniarm.dtsi
rename to arch/arm/dts/rk3288-tinker.dtsi
diff --git a/arch/arm/mach-rockchip/rk3288-board.c b/arch/arm/mach-rockchip/rk3288-board.c
index 8bf45f7..9894a25 100644
--- a/arch/arm/mach-rockchip/rk3288-board.c
+++ b/arch/arm/mach-rockchip/rk3288-board.c
@@ -60,7 +60,7 @@ int rk3288_qos_init(void)
 	writel(val, CPU_AXI_QOS_PRIORITY + VIO1_VOP_QOS);
 
 	if (!fdt_node_check_compatible(gd->fdt_blob, 0,
-				       "rockchip,rk3288-miniarm"))
+				       "rockchip,rk3288-tinker"))
 	{
 		/* set isp qos to higher priority */
 		writel(val, CPU_AXI_QOS_PRIORITY + VIO1_ISP_R_QOS);
diff --git a/arch/arm/mach-rockchip/rk3288/Kconfig b/arch/arm/mach-rockchip/rk3288/Kconfig
index 54545f3..c94df4e 100644
--- a/arch/arm/mach-rockchip/rk3288/Kconfig
+++ b/arch/arm/mach-rockchip/rk3288/Kconfig
@@ -33,10 +33,10 @@ config TARGET_POPMETAL_RK3288
 	  2GB DDR3. Expansion connectors provide access to I2C, SPI, UART,
 	  GPIOs and display interface.
 
-config TARGET_MINIARM_RK3288
-	bool "miniarm-RK3288"
+config TARGET_TINKER_RK3288
+	bool "Tinker-RK3288"
 	help
-	  Miniarm is a RK3288-based development board with 2 USB ports, HDMI,
+	  Tinker is a RK3288-based development board with 2 USB ports, HDMI,
 	  micro-SD card, audio, Gigabit Ethernet. It also includes on-board
 	  8GB eMMC and 2GB of SDRAM. Expansion connectors provide access to
 	  I2C, SPI, UART, GPIOs.
@@ -115,6 +115,6 @@ source "board/rockchip/evb_rk3288/Kconfig"
 
 source "board/rockchip/fennec_rk3288/Kconfig"
 
-source "board/rockchip/miniarm_rk3288/Kconfig"
+source "board/rockchip/tinker_rk3288/Kconfig"
 
 endif
diff --git a/board/rockchip/miniarm_rk3288/MAINTAINERS b/board/rockchip/miniarm_rk3288/MAINTAINERS
deleted file mode 100644
index 7537b8f..0000000
--- a/board/rockchip/miniarm_rk3288/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-MINIARM-RK3288
-M:	Lin Huang <hl@rock-chips.com>
-S:	Maintained
-F:	board/rockchip/miniarm_rk3288
-F:	include/configs/miniarm_rk3288.h
-F:	configs/miniarm-rk3288_defconfig
diff --git a/board/rockchip/miniarm_rk3288/Kconfig b/board/rockchip/tinker_rk3288/Kconfig
similarity index 64%
rename from board/rockchip/miniarm_rk3288/Kconfig
rename to board/rockchip/tinker_rk3288/Kconfig
index 529c09f..bca6c37 100644
--- a/board/rockchip/miniarm_rk3288/Kconfig
+++ b/board/rockchip/tinker_rk3288/Kconfig
@@ -1,13 +1,13 @@
-if TARGET_MINIARM_RK3288
+if TARGET_TINKER_RK3288
 
 config SYS_BOARD
-	default "miniarm_rk3288"
+	default "tinker_rk3288"
 
 config SYS_VENDOR
 	default "rockchip"
 
 config SYS_CONFIG_NAME
-	default "miniarm_rk3288"
+	default "tinker_rk3288"
 
 config BOARD_SPECIFIC_OPTIONS # dummy
 	def_bool y
diff --git a/board/rockchip/tinker_rk3288/MAINTAINERS b/board/rockchip/tinker_rk3288/MAINTAINERS
new file mode 100644
index 0000000..cddceaf
--- /dev/null
+++ b/board/rockchip/tinker_rk3288/MAINTAINERS
@@ -0,0 +1,6 @@
+TINKER-RK3288
+M:	Lin Huang <hl@rock-chips.com>
+S:	Maintained
+F:	board/rockchip/tinker_rk3288
+F:	include/configs/tinker_rk3288.h
+F:	configs/tinker-rk3288_defconfig
diff --git a/board/rockchip/miniarm_rk3288/Makefile b/board/rockchip/tinker_rk3288/Makefile
similarity index 79%
rename from board/rockchip/miniarm_rk3288/Makefile
rename to board/rockchip/tinker_rk3288/Makefile
index 9419b91..432367f 100644
--- a/board/rockchip/miniarm_rk3288/Makefile
+++ b/board/rockchip/tinker_rk3288/Makefile
@@ -4,4 +4,4 @@
 # SPDX-License-Identifier:     GPL-2.0+
 #
 
-obj-y	+= miniarm-rk3288.o
+obj-y	+= tinker-rk3288.o
diff --git a/board/rockchip/miniarm_rk3288/miniarm-rk3288.c b/board/rockchip/tinker_rk3288/tinker-rk3288.c
similarity index 100%
rename from board/rockchip/miniarm_rk3288/miniarm-rk3288.c
rename to board/rockchip/tinker_rk3288/tinker-rk3288.c
diff --git a/configs/miniarm-rk3288_defconfig b/configs/tinker-rk3288_defconfig
similarity index 95%
rename from configs/miniarm-rk3288_defconfig
rename to configs/tinker-rk3288_defconfig
index 2b6bd0b..bf7fec8 100644
--- a/configs/miniarm-rk3288_defconfig
+++ b/configs/tinker-rk3288_defconfig
@@ -3,9 +3,9 @@ CONFIG_ARCH_ROCKCHIP=y
 CONFIG_SYS_MALLOC_F_LEN=0x2000
 CONFIG_ROCKCHIP_RK3288=y
 CONFIG_ROCKCHIP_SPL_BACK_TO_BROM=y
-CONFIG_TARGET_MINIARM_RK3288=y
+CONFIG_TARGET_TINKER_RK3288=y
 CONFIG_SPL_STACK_R_ADDR=0x80000
-CONFIG_DEFAULT_DEVICE_TREE="rk3288-miniarm"
+CONFIG_DEFAULT_DEVICE_TREE="rk3288-tinker"
 CONFIG_SILENT_CONSOLE=y
 CONFIG_CONSOLE_MUX=y
 # CONFIG_DISPLAY_CPUINFO is not set
diff --git a/doc/README.rockchip b/doc/README.rockchip
index 43cafc7..186a1a0 100644
--- a/doc/README.rockchip
+++ b/doc/README.rockchip
@@ -42,7 +42,7 @@ At present seven RK3288 boards are supported:
    - Fennec RK3288 - use fennec-rk3288 configuration
    - Firefly RK3288 - use firefly-rk3288 configuration
    - Hisense Chromebook - use chromebook_jerry configuration
-   - Miniarm RK3288 - use miniarm-rk3288 configuration
+   - Tinker RK3288 - use tinker-rk3288 configuration
    - PopMetal RK3288 - use popmetal-rk3288 configuration
    - Radxa Rock 2 - use rock2 configuration
 
diff --git a/include/configs/miniarm_rk3288.h b/include/configs/tinker_rk3288.h
similarity index 100%
rename from include/configs/miniarm_rk3288.h
rename to include/configs/tinker_rk3288.h